## VMs

- There is now support for KVM/QEMU virtual machines that can be accessed via the libvirt CLI tools `virsh`. This includes support for other driver URLs as well aside from KVM and QEMU. This integration is available starting from the homelab plan and can be used for free for two weeks after this release using the new release preview
- You can now override a VM IP if you're using an advanced networking setup where the default IP detection is not suitable
- Fix remote VM SSH connections not being able to use the keys and identities from the local system
- There is now a new restart button for containers and VMs

## File browser

- There is now a new option in the context menu of a tab to pin it, allowing for having a split view with two different file systems
- There is now the option to dock terminals in the file browser (this is only available on Windows for now). You can disable this in Settings -> File browser -> Terminal docking if you don't like it
- The previous system history tab is now always shown
- You can now change the default download location for the move to downloads button

## Shell sessions

Many improvements have been implemented for reusability of shell sessions running in the background. Whenever you access a system or a parent system, XPipe will connect to it just as before but keep this session open in the background for some time, under the assumption that you will typically perform multiple actions shortly afterward. This will improve the speed of many actions and also results in less authentication prompts when you are using something like 2FA.

## Terminals

- Closing a terminal tab/window while the session is loading will now cancel the loading process in XPipe as well
- A newly opened terminal will now regain focus after any password prompt was entered in xpipe

## Security updates

There's now a new mechanism in place for checking for security updates separately from the normal update check. This is important going forward, to be able to act quickly when any security patch is published, so that all users have the possibility to get notified even if they don't follow announcements on the GitHub repo or on Discord. You can also disable this functionality in the settings if you want.

## Other

- The application style has been reworked
- The settings menu now shows a restart button when a setting has been changed that requires a restart to apply
- There is now an intro to scripts to provide some more information before using scripts
- Add ability to enable agent forwarding when using the SSH-Agent for identities
- The .rpm releases are now signed

## Fixes

- Fix Proxmox detection not working when not logging in as root
- Fix tunnels not closing properly when having to be closed forcefully
- Fix vmware integration failing when files other than .vmx were in the VM directories
- Fix Tabby not launching properly on Windows
- Fix SSH and docker issues with home assistant systems
- Fix git readme not showing connections in nested children categories
- Fix Windows Terminal Preview and Canary not being recognized
- Fix style issues with the mocha theme
- Fix color contrast for some themes
- Fix system dark mode changes not being applied if they were changed while XPipe was not running
